Attribute VB_Name = "Module1"
'========================================================
'PCBook2
'Version 1.2
'Copyright (c) 1999 Ziff Davis Inc
'All rights Reserved
'First published in PC Magazine, US Edition April 7, 1999
'Written by Jay Munro
'========================================================
'Revisions:
' 3/15/99  removed space ltrim$ in PagePrintOutput
'       converted font and print selection over to api calls
'       added functions to load fonts & printers into custom
'       dialog boxes
'
'3/16/99  changed font,size and printer selection to API calls and
'         custom dialog boxes
'3/25/99  converted tab control from VB6 sstab to VB5 TabStrip
'         converted help call to api, deleted comctl32 (common dialog control)
'
'6/22/99  added bottom fed printer support
'         Fixed NT problem
'         fixed bad feed problem
'7/9/99   added full path back to file name
'7/10/99  added printer,font, fontsize display to status
'7/30/99  added lineweight, linecolor, explicitly set linecolor

'7/30/99  added offset values to II file
'         OffsetTop
'         OffsetLeft
'         OffsetRight
'         Offsetbottom
'
'8/1/99 Made margins available for adjustment in INI file
'       XEdgeBorder1    left / right borders for 1 up
'       YEdgeBorder1    top / bottom borders for 1 up
'       XEdgeBorder2    left / right borders for 2 up
'       YEdgeBorder2    top / bottom borders for 2 up
'       XEdgeBorder4    left / right borders for 4 up
'       YEdgeBorder4    top / bottom borders for 4 up
'       BookletGutter   margin between 2 up booklet pages
'       TwoUpGutter     margin between 2 up pages
'       FourUpGutter    margin between 4 up pages
'       BoxToText       space from text to box frame (subtracted from borders)
'
'version 1.2
'10/10/99 Fixed orientation problem with signatures,
'       Re-tested NT4 SP/4 file picking problem.
'       Added code to PCBook2 to prevent running multiple instances.

'1/4/2000
'    Added code to GetOptions sub to fix DoWordWrap in .ini file
'    Added code to header/footer sub to fix alternating page numbers
'    on non booklet printing
'    Added code to save Tabcount to .INI file
'1/21/2000
'    changed cancel button to close when done printing
'
'1/30/2000
'    reworked help file, added images and text

'========================================================
'--- global variables

Global PtrArray&()      'array to hold pointers into file page breaks
Global MaxLines%        'maximum lines per page
Global FF$, lf$         'form feed and line feed constants
Global Tb$              'tab character constant
Global CRLF$            'character/linefeed constant
Global CurrentDate$     'keeps date for header/footers
Global TempFile$        'temporary file name
Global TextFile$        'original file name
Global iniFile$         'name of INI file for saved options
Global AppName$         'application file name for INI files
Global DialogTitle$     'dialog title (PCBook2)
Global helpfile$        'help file
Global BreakMsg$(3)        'message to tell user to flip paper in printer
Global printMsg$(3)     'message to display when printing pages
Global tabcount%        'number of spaces to use when replacing tabs
Global CurrentFont$     'name of current font
Global currentfontsize%  'size of font
Global DefaultScreenFont$   'saved name of default screen font for
Global lpDeviceName$
Global lpPort$
Global iIndex
Global lineweight As Integer  ' weight of box around
Global linecolor As Long      ' color of line

'fudge factors
Type Offset
    Top As Integer
    Left As Integer
    Right As Integer
    Bottom As Integer
End Type
Global Ofs As Offset

Global XEdgeBorder1 As Integer
Global YEdgeBorder1 As Integer

Global XEdgeBorder2 As Integer
Global YEdgeBorder2 As Integer

Global XEdgeBorder4 As Integer
Global YEdgeBorder4 As Integer

Global BookletGutter As Integer
Global TwoUpGutter  As Integer
Global FourUpGutter As Integer
Global BoxToText As Integer
                            
Global LastTempFile As String   'keep clean if unnatural exit

Global LeftSide%, LeftCenter%
Global Rightside%, RightCenter%

Global LPageWidth%, RPageWidth% 'physical width of page (in twips)
Global PageWidth%               'physical width of page (in twips)

Public Type OPENFILENAME        'struct used to call OpenFile dialog
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Global pOpenFileName As OPENFILENAME

'type structure lets us use a generic header & footer routine
' by flagging what needs to be done in one nice array
Type HeadFootFlags
  DoHf As Integer        'flags to do header or footer (0) = Head,(1) = footer
  CurDate As Integer     'do date
  FileTitle As Integer   '
  PgNumber As Integer    '
End Type
Global HFFlag(2)        'our global array  (0) = Head,(1) = footer

Type flags                         'Misc flag and variables
  DoHf(2) As Integer        'flags to do header or footer (0) = Head,(1) = footer
  CurDate(2) As Integer     'do date
  FileTitle(2) As Integer   '
  PgNumber(2) As Integer    '
  LineLen As Integer        'physical length of line in twips
  MaxPages As Long       'maximum number of pages to use (2024 default)
  TotalPages As Long     'total pages
  papersize As Integer
  SheetCt As Integer        'total number of sheets (pgcount/4)
  DoSig As Integer          'signature flag
  SigMax As Integer         'maximum number of signatures
  Sigcount As Integer       'actual number of signatures
  Orientation As Integer    'orientation (always portrait in this version)
  ExpandTab As Integer      'do expand tab flag
  WordWrap As Integer       'do word wrap flag
  AverageWidth As Integer   'a sample width to start with
  fontsize As Integer       'current font size
  LineSpace As Integer
  MaxLen As Integer         'Maximum characters to grab to test for line width
  MaxLine As Integer        'maximum number of lines per page
  FontDisplayed As Integer  'is the default font shown?
  CurFontIndex As Integer   'current font in list box
  printermode As Integer    '1,2,3  Normal,Rear tray,double
  LineMultiple As Single    'fudge factor for line height
  WidthFudge As Integer     'fudge factor for number chars per line
  LM As Integer             'LayoutMode  '0,1,2,3 (for 1up,2up,3up,booklet)
  SPN As Integer            'Single page number page number for single sides (1- 4)
                            'only when doing WinPrn mode.
  DoBox As Integer          'flag to do box or not.
  DoBook As Integer         'booklet flag
  PFont As Variant          'save printer font name
  PagesPerSig As Integer    'keep track of number of pages
  DefTab As Integer         'default tab shown at startup
  GoodPtr As Boolean        'flag to track if user keeps bad printer
  DoPath As Integer         'flag to strip path info 0 = no path, 1 = do path
End Type

Global PC As flags

Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenFileName As OPENFILENAME) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Public Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Type LOut           'layout struct for page
    '--- individual page specifications
    rFontSize As Integer    'working font size
    rDefaultSize As Integer 'default
    rLineSpace As Integer   'recommended line spacing (fontsize + space)
    rLinesPerPage As Integer 'recommended lines per page
    rVPage As Integer       'number of virtual pages per sheet
    rX1(4) As Long
    rY1(4) As Long
    rOrientation As Integer
    rVpagelength As Long    'virtual page length (twips)
    rVpageWidth As Long     'virtual page width (twips)
    rFontName As String  '
End Type

Global Layout(4) As LOut

Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32

Type devmode
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type
Global lpdevmode As devmode
Declare Function DeviceCapabilities Lib "winspool.drv" Alias "DeviceCapabilitiesA" (ByVal lpDeviceName As String, ByVal lpPort As String, ByVal iIndex As Long, ByVal lpOutput As String, lpdevmode As devmode) As Long
Public Const DC_DUPLEX = 7
Public Const DC_ORIENTATION = 17
Public Const DC_PAPERNAMES = 16
Public Const DC_PAPERS = 2
Public Const DC_PAPERSIZE = 3
Public Const DC_TRUETYPE = 15


Public Const LF_FACESIZE = 32
Public Const LF_FULLFACESIZE = 64

Public Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(1 To LF_FACESIZE) As Byte
End Type

Public Type PrintDlg
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        hdc As Long
        flags As Long
        nFromPage As Integer
        nToPage As Integer
        nMinPage As Integer
        nMaxPage As Integer
        nCopies As Integer
        hInstance As Long
        lCustData As Long
        lpfnPrintHook As Long
        lpfnSetupHook As Long
        lpPrintTemplateName As String
        lpSetupTemplateName As String
        hPrintTemplate As Long
        hSetupTemplate As Long
End Type
Public Type CHOOSEFONT
        lStructSize As Long
        hwndOwner As Long          '  caller's window handle
        hdc As Long                '  printer DC/IC or NULL
        lpLogFont As Long
        iPointSize As Long         '  10 * size in points of selected font
        flags As Long              '  enum. type flags
        rgbColors As Long          '  returned text color
        lCustData As Long          '  data passed to hook fn.
        lpfnHook As Long           '  ptr. to hook function
        lpTemplateName As String     '  custom template name
        hInstance As Long          '  instance handle of.EXE that
                                       '    contains cust. dlg. template
        lpszStyle As String          '  return the style field here
                                       '  must be LF_FACESIZE or bigger
        nFontType As Integer          '  same value reported to the EnumFonts
                                       '    call back with the extra FONTTYPE_
                                       '    bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long           '  minimum pt size allowed &
        nSizeMax As Long           '  max pt size allowed if
                                       '    CF_LIMITSIZE is used
End Type

Public Const CF_PRINTERFONTS = &H2
Public Const CF_APPLY = &H200&
Public Const CF_LIMITSIZE = &H2000&
Public Const CF_NOSTYLESEL = &H100000
Public Const CF_SCALABLEONLY = &H20000
Public Const CF_TTONLY = &H40000


Global cf As CHOOSEFONT
Global pd As PrintDlg
Global lgf As LOGFONT

Public Declare Function CHOOSEFONT Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As CHOOSEFONT) As Long
Public Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PrintDlg) As Long

Public Type NEWTEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
        ntmFlags As Long
        ntmSizeEM As Long
        ntmCellHeight As Long
        ntmAveWidth As Long
End Type
Global lpNLF As LOGFONT
Global lpNTM As NEWTEXTMETRIC

'  tmPitchAndFamily flags
Public Const TMPF_DEVICE = &H8
Public Const TMPF_FIXED_PITCH = &H1
Public Const TMPF_TRUETYPE = &H4
Public Const TMPF_VECTOR = &H2

'  EnumFonts Masks
Public Const RASTER_FONTTYPE = &H1
Public Const DEVICE_FONTTYPE = &H2
Public Const TRUETYPE_FONTTYPE = &H4

Declare Function EnumFontFamilies Lib "gdi32" Alias _
     "EnumFontFamiliesA" _
     (ByVal hdc As Long, ByVal lpszFamily As String, _
     ByVal lpEnumFontFamProc As Long, LParam As Any) As Long

Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, _
     ByVal hdc As Long) As Long

Public Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
Public Const HELP_CONTENTS = &H3&
Public Const HELP_QUIT = &H2
Public Const HELP_SETCONTENTS = &H5&
Public Const HELP_SETWINPOS = &H203&
Public Type HELPWININFO          'used for setwinpos
        wStructSize As Long
        x As Long
        y As Long
        dx As Long
        dy As Long
        wMax As Long
        rgchMember As String * 2
End Type

'end of declarations

Sub MaxLinePerPage()
On Error GoTo MaxError

'set font and size
Printer.fontsize = Layout(PC.LM).rFontSize
Printer.FontName = Layout(PC.LM).rFontName

'get orientation
PC.Orientation = Layout(PC.LM).rOrientation

If PC.Orientation = 0 Then
   PC.Orientation = Printer.Orientation
Else
   Printer.Orientation = PC.Orientation
End If

'get font line space (font height * multiplier)
Layout(PC.LM).rLineSpace = Printer.TextHeight("ABCDEFGHIJKLMNOPQRSTUVWXYZ") * PC.LineMultiple

PC.AverageWidth = Printer.TextWidth("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789") \ 62

PC.MaxLen = (Layout(PC.LM).rVpageWidth \ PC.AverageWidth) + PC.WidthFudge  'estimated number of chars to

Pageheight = Layout(PC.LM).rVpagelength

PC.MaxLine = Pageheight \ Layout(PC.LM).rLineSpace

SubLines% = 0           'set up a variable to leave room for the header and footer
If PC.DoHf(1) Then SubLines% = SubLines% + 3       'leave 2 lines at bottom free
If PC.DoHf(0) Then SubLines% = SubLines% + 2
PC.MaxLine = PC.MaxLine - SubLines%
Exit Sub
MaxError:
If err = 380 Then MsgBox "your printer does not support features that PCBook II needs" + CRLF$ + "please choose another printer"

End Sub
Function SheetCount%(tPage%)
Select Case PC.LM
    Case 2, 3         'booklet and 4 up
'--- Figure number of phyical pages (sheets) needed
        If tPage% Mod 4 Then                          'Even multiples of 4 only
            tPage% = tPage% + (4 - tPage% Mod 4)         '  correct for less
        End If
        SheetCount% = tPage% \ 4
    Case 0          '1 up
        SheetCount% = tPage%
    Case 1          '2 up
        If tPage% Mod 2 Then
            tPage% = tPage + (2 - tPage% Mod 2)
        End If
        SheetCount% = tPage \ 2
    Case Else
End Select

End Function
Function ParseFileName$(FullPath$)
'Parse file name from full path to put in header or footer

If InStr(FullPath$, "\") Then
  'get the last backslash and return everything to the right of it
  ParseFileName$ = Mid$(FullPath$, InstrRevJ(FullPath$, "\") + 1)
Else
  'if no path,return what came in
  ParseFileName$ = FullPath$
End If
End Function

Function SigCalc&(Sheet%, SigMax%)
'-------- Calculate signature breaks
' always rounds up to even
    If SigMax% Then                     'Can't divide by zero
      If Sheet% Mod SigMax% Then
        SigCalc& = (Sheet% \ SigMax%) + 1
      Else
        SigCalc& = Sheet% \ SigMax%
      End If
    Else
       SigCalc& = 0                     'report 0 if no sigs
    End If
End Function

'Static Sub BuildArray(PtrArray&(), PgCount%)
Static Sub BuildArray()
' The BuildArray module is the core of the pcbook program.
' It reads the file and calculates how many pages and how they should break
' based on the number of lines per page.

'--- TempFile$ is shared from the main module
   Offset& = 1                                  'Start of file (seek point)
   Open TempFile$ For Binary As #1 Len = 1      'Open file to check
   TotalSize& = LOF(1)                          'Get LEN of file so we don't read too far
   FileLeft& = TotalSize&                       'Setup a counter to show whats left
   Bufsize& = 32766                             'a comfortable size
   PgCount% = 1                                 'Initialize page count
   PtrArray&(PgCount%) = 1                      'First pointer is always 1
   LnCount% = 0                                 'Initialize line count
   'double check for first run
   If PC.MaxLine Then
     MaxLines% = PC.MaxLine                       'get max number of lines
   Else
     If MaxLines% Then
       PC.MaxLine = MaxLine%        'default has been set
     Else
       MaxLines% = 55               'default hasn't been set
       PC.MaxLine = MaxLine%
     End If
   End If
      
GetPage:                                               'Read the file
  If FileLeft& < Bufsize& Then                 'Check amount left to read
    buffer$ = Space$(FileLeft&)                'If less than our buffer, use lessor
  Else
    buffer$ = Space$(Bufsize&)                 'Otherwise use full buffer size
  End If

  Get #1, Offset&, buffer$                     'Read in a buffers worth
  StPtr% = 1                                   'Pointer into buffer$

PageCheck:
  TempLn% = InStr(StPtr%, buffer$, lf$)        ' Position of next linefeed
  TempPg% = InStr(StPtr%, buffer$, FF$)        ' Position of next pagefeeds

  If TempPg% Then                              ' If there was a page feed,
    If TempPg% < TempLn% Or TempLn% = 0 Then   ' was it before our linefeed?
      TempLn% = TempPg%                        ' YES, treat as a LF for
    Else                                       ' purpose of line wrap.
      TempPg% = 0                              ' NO, ignore FF and clear flag
    End If                                     ' when LF preceeds the FF.
  End If                                       ' We'll catch the FF again
                                               ' on the next pass.
  If TempLn% Then                              ' Linefeed

PageBreak:
    LnCount% = LnCount% + 1                   'Increment line count
    If LnCount% = MaxLines% Or TempPg% <> 0 Then
      PgCount% = PgCount% + 1
      PtrArray&(PgCount%) = Offset& + TempLn% 'point to next in point in file
      If PgCount% > PC.MaxPages Then
        PgCount% = PC.MaxPages              'just filled in PtrArray&(PC.MaxPages)
'-- update user
        MsgBox "Too many pages - printing only " & PC.MaxPages
        GoTo EndBuild
      End If
      LnCount% = 0
    End If

    StPtr% = TempLn% + 1                       'point ahead 1 byte for next scan
    If StPtr% <= Len(buffer$) Then GoTo PageCheck  'keep checking
  End If

   Offset& = Offset& + Len(buffer$)              'Pointer into file (tally)
  FileLeft& = TotalSize& - Offset& + 1
  If Offset& <= TotalSize& Then
    Call frmStatus.SetProgress(TotalSize&, TotalSize& - FileLeft&)
    GoTo GetPage
  End If

  If PtrArray&(PgCount%) <= TotalSize& Then
    PtrArray&(PgCount% + 1) = TotalSize& + 1    'Set last pointer to end of file
  Else
    PgCount% = PgCount% - 1                     'we already saved the last value
  End If                                        'and PgCount% is 1 too high

EndBuild:
  Call frmStatus.SetProgress(TotalSize&, TotalSize&)
  Close #1                                      'Close input file
  PC.TotalPages = PgCount%                      'record our page count
End Sub                                         'End of BuildArray Module

Sub PageOrder(PrintMode%)
'--------------------------------------------------------------
'This sub calls the page printing routine in the correct order
'for normal, rear tray or double side printing
'In the printing routine X = MaxSheet (= True) then it's the
'last page so send an EndDoc to prevent a blank page at the end
'--------------------------------------------------------------
Dim x As Integer

Call frmMain.ShowStatus("Printing " + printMsg$(PC.LM))

maxsheet = PC.SheetCt                           'max number of sheets

Open TempFile$ For Binary As #1                 'open parsed file

Call frmMain.ShowStatus("Printing Side 1")     ''show status'call PagePrint(Side%,sheet%)

On Error GoTo POError                           'error 380 if it won't go to landscape
Printer.Orientation = PC.Orientation            'landscape usually

'Network printer requires end doc on each pass to print
Select Case UCase$(Printer.Port)
  Case "LPT1:", "LPT2:", "LPT3:", "FILE:"
    networkprinter = False
  Case Else
    networkprinter = True
  End Select
  
'Note below, Side B is called with "(X=MaxSheet) so unless
'it's the last sheet it passes a False flag
Select Case PC.printermode

Case 1                          '--- straight
   For x = 1 To maxsheet         'count up first side
     Call frmStatus.SetProgress(maxsheet, x)
    ' If networkprinter Then
       Call PagePrint(1, x, (x = maxsheet))
    ' Else
    '   'Call PagePrint(1, x, False)       'call with side A
    '   Call PagePrint(1, x, (x = maxsheet))       'call with side A
    ' End If
   Next x

'tell user that we're ready for them to flip the paper
   If MsgBox(BreakMsg$(PC.printermode), vbOKCancel, DialogTitle$) = vbCancel Then
      Printer.EndDoc                    'reset printer
      GoTo PageOrderExit
   End If
    
   Call frmMain.ShowStatus("Printing Side 2") 'Report on progress
   
   'If networkprinter Then
     Printer.Orientation = PC.Orientation        'printer gets reset
   'End If
    
   For x = maxsheet To 1 Step -1     'count down other side
     Call PagePrint(2, x, (x = 1))   'call with side B
     Call frmStatus.SetProgress(maxsheet, maxsheet - x)
   Next x

Case 0, 3                         '--- flip
    For x = 1 To maxsheet         'count up one side
     Call frmStatus.SetProgress(maxsheet, x)
     If networkprinter Then
       Call PagePrint(1, x, (x = maxsheet))
     Else
       Call PagePrint(1, x, (x = maxsheet))
       'Call PagePrint(1, x, False)       'call with side A
     End If
    Next x
    
    If MsgBox(BreakMsg$(PC.printermode), vbOKCancel, DialogTitle$) = vbCancel Then
        Printer.EndDoc                    'reset printer
        GoTo PageOrderExit
    End If
    
    Call frmMain.ShowStatus("Printing Side 2") 'Report on progress
    
   ' If networkprinter Then
      Printer.Orientation = PC.Orientation        'printer gets reset
   ' End If
    
    For x = 1 To maxsheet         'count up the other side
      Call frmStatus.SetProgress(maxsheet, x)
      Call PagePrint(2, x, (x = maxsheet))       'call with side B
    Next x
    
Case 2                          '--- Double side support
    Call frmMain.ShowStatus("Printing Duplex")
    DupHold = Printer.Duplex                'save default setting
    Printer.Duplex = vbPRDPVertical         'set on short side
    For x = 1 To maxsheet                   'count down one side
      Call frmStatus.SetProgress(maxsheet, x)
      Call PagePrint(1, x, False)            'call with side A
      Call PagePrint(2, x, (x = maxsheet))   'call with side B
    Next x
    Printer.Duplex = DupHold                'return default setting

Case Else
End Select

PageOrderExit:
Close #1
Call frmMain.ShowStatus("Printing Completed")   'Report on progress
Exit Sub

POError:

  If err = 380 Then
      MsgBox "Your printer does not support" + CRLF$ + "a feature PCBook II needs"
  Else
     MsgBox Error
  End If
  Close
  'Resume
  
End Sub

Sub PageOrderWithSigs(PrintMode%)
'--------------------------------------------------------------
'This sub calls the page printing routine in the correct order
'for normal, rear tray or double side printing, with Signatures
'it is the same basic code as the PageOrder routine, but with
'special handling.  Yes, I could have coded it into one routine
'but it is easier to understand without a pile more if/thens
'--------------------------------------------------------------
'note for performance, printing with and without sigs
' are seperate.

Dim x As Integer
Call frmMain.ShowStatus("Printing " + printMsg$(PC.LM))

Open TempFile$ For Binary As #1
Call frmMain.ShowStatus("Printing Side 1")     'show status'call PagePrint(Side%,sheet%)

On Error GoTo POWSError            'error 380

'Note below, Side B is called with "(X=MaxSheet) so unless
'it's the last sheet it passes a False flag
    
If PC.SheetCt Mod PC.Sigcount Then
  PC.PagesPerSig = (PC.SheetCt \ PC.Sigcount) + 1
Else
  PC.PagesPerSig = PC.SheetCt \ PC.Sigcount 'get our offset
End If

SigPages = PC.PagesPerSig * 4             'pages per signature

Dim CurSig As Integer

For Side = 1 To 2
  'Printer.Orientation = Layout(PC.LM).rOrientation '  PC.Orientation     'landscape usually
  Select Case PC.printermode
  
  Case 1, 3           'straight
  
   If Side = 1 Then                  '---- Side A
     For CurSig = 1 To PC.Sigcount
       For x = 1 To PC.PagesPerSig         'count down one side
           Call PagePrintWithSigs(1, x, CurSig, (x = PC.PagesPerSig And CurSig = PC.Sigcount))
       Next x
     Next CurSig
   Else
     
     If MsgBox(BreakMsg$(PC.printermode), vbOKCancel, DialogTitle$) = vbCancel Then
       Printer.EndDoc                    'reset printer
       GoTo PageOrderWSExit
     End If
     
     Call frmMain.ShowStatus("Printing Side 2") 'Report on progress
     
       Printer.Orientation = PC.Orientation        'printer gets reset
   
'----- print other side
   '---- Side B
     For CurSig = PC.Sigcount To 1 Step -1
        For x = PC.PagesPerSig To 1 Step -1     'count down one side
         Call PagePrintWithSigs(2, x, CurSig, (x = 1 And CurSig = 1)) 'call with side B
       Next x
     Next CurSig
   End If
   '-----------
  Case 0, 3                           '--- flip and bottom fed
   If Side = 1 Then
     For CurSig = 1 To PC.Sigcount  'sig loop
       For x = 1 To PC.PagesPerSig    'count down one side
           Call PagePrintWithSigs(1, x, CurSig, (x = PC.PagesPerSig And CurSig = PC.Sigcount))
       Next x
     Next CurSig
   Else             'side = 2
     If MsgBox(BreakMsg$(PC.printermode), vbOKCancel, DialogTitle$) = vbCancel Then
        Printer.EndDoc                    'reset printer
        GoTo PageOrderWSExit
     End If
     
     Call frmMain.ShowStatus("Printing Side 2") 'Report on progress
     
     If networkprinter Then
       Printer.Orientation = PC.Orientation        'printer gets reset
       Printer.ScaleMode = vbTwips
     End If
     For CurSig = 1 To PC.Sigcount  'count down one side
       For x = 1 To PC.PagesPerSig         'count down one side
         Call PagePrintWithSigs(2, x, CurSig, (x = PC.PagesPerSig And CurSig = PC.Sigcount))      'call with side B
       Next x
     Next CurSig
   End If
  
  Case 2                          '--- Double side support
    Call frmMain.ShowStatus("Printing Double Sided") 'Report on progress
    If Side = 1 Then
      eMsg$ = "Printing Duplex"
      DupHold = Printer.Duplex                'save default setting
      Printer.Duplex = vbPRDPVertical         'set on short side
      For CurSig = 1 To PC.Sigcount
       For x = 1 To maxsheet                   'count down one side
         Call PagePrintWithSigs(1, x, CurSig, False)           'call with side A
         'Call PagePrintWithSigs(2, X, CurSig, (X = MaxSheet And CurSig = PC.Sigcount))  'call with side B
         Call PagePrintWithSigs(2, x, CurSig, (x = PC.PagesPerSig And CurSig = PC.Sigcount))  'call with side B
       Next x
      Next CurSig
      Printer.Duplex = DupHold                'return default setting
    End If
  Case Else
  End Select
  
Next Side
PageOrderWSExit:

Close #1
Call frmMain.ShowStatus("Printing Completed") 'Report on progress
Exit Sub

POWSError:
  If err = 380 Then
      MsgBox "Your printer does not support" + CRLF$ + "a feature PCBook II needs"
  Else
     MsgBox Error
  End If
  Close
  Resume here2
here2:
End Sub
Sub PagePrint(Side%, Sheet%, EndFlag As Boolean)
'prints a booklet
On Error GoTo PrinterError  'if we get an error
maxsheet% = PC.SheetCt * 4  'multiply sheets * 4
If PC.DoHf(0) Then
    Fudge% = (Layout(PC.LM).rLineSpace * 2)
Else
    Fudge% = 0
End If

'--- calculate page number for left and right based on side
'    and sheet number
'    this algorithm is the meat of the booklet algorithm

Select Case Side%
Case 1          'Side A
    Rightside% = (Sheet% * 2) - 1               'A Right
    LeftSide% = maxsheet% - ((Sheet% * 2) - 2)  'A left
Case 2          'Side B
    Rightside% = maxsheet% - ((Sheet% * 2) - 1) 'B Right
    LeftSide% = Sheet * 2                       'B left
End Select
   
   If Rightside% Then
     If PtrArray&(Rightside% + 1) Then   'Put in This space intentionally blank
       '--- check and call header routine
       PC.SPN = 2       'right side
       If PC.DoBox Then Call PrintBox(lineweight)  '1 = line weight
       If PC.DoHf(0) Then Call GenHeaderFooter(Rightside%, 0) 'Header if needed
       buffer$ = Space$(PtrArray&(Rightside% + 1) - PtrArray&(Rightside%))
       Get #1, PtrArray&(Rightside%), buffer$      'Read in a page
       If InStr(buffer$, FF$) Then                 'If the last character is a PF
         Call PagePrintOutput(Layout(PC.LM).rX1(2), Layout(PC.LM).rY1(2) + Fudge%, Left$(buffer$, InStr(buffer$, FF$) - 1))
       Else
         Call PagePrintOutput(Layout(PC.LM).rX1(2), Layout(PC.LM).rY1(2) + Fudge%, buffer$)
       End If
       
       If PC.DoHf(1) Then Call GenHeaderFooter(Rightside%, 1) 'Footer if needed
       
     End If
   End If
NextPage:
    If LeftSide% Then
      If PtrArray&(LeftSide% + 1) Then
        If LeftSide% <> Rightside% Then
          PC.SPN = 1        'left side of page
         
          If PC.DoBox Then Call PrintBox(lineweight)  '1 = line weight
       
          If PC.DoHf(0) Then Call GenHeaderFooter(LeftSide%, 0) 'Header if needed
            If PtrArray&(LeftSide% + 1) Then
              buffer$ = Space$(PtrArray&(LeftSide% + 1) - PtrArray&(LeftSide%))                'Setup buffer for input
              Get #1, PtrArray&(LeftSide%), buffer$       'Read in a page
              If InStr(buffer$, FF$) Then   'if the last character is a PF
                Call PagePrintOutput(Layout(PC.LM).rX1(1), Layout(PC.LM).rY1(1) + Fudge%, Left$(buffer$, InStr(buffer$, FF$) - 1))
              Else                                        'print only text
            '-- print page
                Call PagePrintOutput(Layout(PC.LM).rX1(1), Layout(PC.LM).rY1(1) + Fudge%, buffer$)
               End If
              If PC.DoHf(1) Then Call GenHeaderFooter(LeftSide%, 1) 'Header if needed
            End If
         End If
      End If
    End If
NextPage1:
    If EndFlag Then
      Printer.EndDoc
    Else
      Printer.NewPage
    End If
    
    Exit Sub
'--- Put in some error handling here
PrinterError:
Resume here1
here1:
    
End Sub
Sub PagePrintWithSigs(Side%, Sheet%, CurSig As Integer, EndFlag As Boolean)

SigPages = PC.PagesPerSig * 4              'pages per signature
On Error GoTo PrinterError2  'if we get an error

'bump down two lines under header
If PC.DoHf(0) Then
    Fudge% = (Layout(PC.LM).rLineSpace * 2)
Else
    Fudge% = 0
End If
      
'calculate our pages
Select Case Side%
Case 1          'Side A
  Rightside% = ((Sheet% * 2) - 1) + ((CurSig - 1) * SigPages) 'ASide
  LeftSide% = (SigPages - ((Sheet% * 2) - 2)) + ((CurSig - 1) * SigPages) 'ASide

Case 2          'Side B
  LeftSide = (Sheet * 2) + ((CurSig - 1) * SigPages)  'BSide
  Rightside = (SigPages - (((Sheet% * 2) - 1))) + ((CurSig - 1) * SigPages) 'BSide

End Select
   If Rightside% Then
     If PtrArray&(Rightside% + 1) Then   'Put in This space intentionally blank
       '--- check and call header routine
       PC.SPN = 2
       
       If PC.DoBox Then Call PrintBox(lineweight)  '1 = line weight
       
       If PC.DoHf(0) Then Call GenHeaderFooter(Rightside%, 0) 'Header if needed
       buffer$ = Space$(PtrArray&(Rightside% + 1) - PtrArray&(Rightside%))
       Get #1, PtrArray&(Rightside%), buffer$      'Read in a page
       
       If InStr(buffer$, FF$) Then                 'If the last character is a PF
          Call PagePrintOutput(Layout(PC.LM).rX1(2), Layout(PC.LM).rY1(2) + Fudge%, Left$(buffer$, InStr(buffer$, FF$) - 1))
       Else
         Call PagePrintOutput(Layout(PC.LM).rX1(2), Layout(PC.LM).rY1(2) + Fudge%, buffer$)
       End If
       '--
      If PC.DoHf(1) Then Call GenHeaderFooter(Rightside%, 1) 'Footer if needed
     End If
   End If
NextPage:
    If LeftSide% Then
      If PtrArray&(LeftSide% + 1) Then
        If LeftSide% <> Rightside% Then
          PC.SPN = 1
           If PC.DoBox Then Call PrintBox(lineweight)  '1 = line weight
           If PC.DoHf(0) Then Call GenHeaderFooter(LeftSide%, 0) 'Header if needed
            If PtrArray&(LeftSide% + 1) Then
              buffer$ = Space$(PtrArray&(LeftSide% + 1) - PtrArray&(LeftSide%))                'Setup buffer for input
              Get #1, PtrArray&(LeftSide%), buffer$       'Read in a page
              If InStr(buffer$, FF$) Then                 'if the last character is a PF
                Call PagePrintOutput(Layout(PC.LM).rX1(1), Layout(PC.LM).rY1(1) + Fudge%, Left$(buffer$, InStr(buffer$, FF$) - 1))
              Else                                        'print only text
            '-- print page
                Call PagePrintOutput(Layout(PC.LM).rX1(1), Layout(PC.LM).rY1(1) + Fudge%, buffer$)
              End If
              If PC.DoHf(1) Then Call GenHeaderFooter(LeftSide%, 1)
            End If
         End If
      End If
    End If
NextPage1:
    If EndFlag Then
       Printer.EndDoc
    Else
       Printer.NewPage
    End If
    
    Exit Sub
'--- Put in some error handling here
PrinterError2:
Resume here2
here2:
       
End Sub

Sub TabExpand(TextFile$)
    tabcount% = frmMain.TCount.Text
    'Tb$ = Chr$(9)          'set in form load
    ST = 1
    ST1 = ST
    S$ = Space$(tabcount%)
Open TextFile$ For Binary As #1
Open TempFile$ For Binary As #2

t$ = 1
x = 1
Do Until EOF(1)
    Get #1, , t$        'Mid$(Buffer$, X, 1)
    '---- fill out tabs
    If t$ = Tb$ Then
      Put #2, , S$
    Else
      Put #2, , t$
    End If
Loop
Close #1
Close #2

End Sub

Sub FileWordWrap(FileName$, TempFile$)
'this is the killer routine of PCBook2. FileWordWrap uses a
'temporary file to create a word wrapped and tab expanded
'file that PCBook2 reads and prints. The temp file is
'created using Windows temp directory and filenames and is
'cleaned up on return. The same temp file is reused throughout a
'single session

    Dim SpaceFlag As Boolean
    Dim T4 As Long
    Dim T1 As Integer
    Dim ProcessedBytes&
        
'--- get values
    tabcount% = frmMain.TCount.Text
    PC.ExpandTab = frmMain.DoTabEx.Value
    
    Bufsize& = 32768                'grab a chunk
    TabConst$ = Space$(tabcount%)
    
    Dim ST As Long
    Dim ST1 As Long
    
    Call MaxLinePerPage         'check lines per page, etc...
    T1% = Layout(PC.LM).rVpageWidth   'PageWidth%            'Printer.Width \ 4
    MaxLen% = PC.MaxLen

'On Error GoTo Problems                      'catch a problem

    Open FileName$ For Binary As #1
    TotalSize& = LOF(1)
    If TotalSize& = 0 Then
        Close #1
        MsgBox "Source File has 0 bytes", vbOKOnly, DialogTitle$
        Exit Sub
    End If
    'if we have a valid file, then set tracking var's
    FileLeft& = TotalSize&
    ProcessedBytes& = FileLeft&

    Open TempFile$ For Binary As #2
    If LOF(2) > 0 Then
       Close #2
       Kill TempFile$
       Open TempFile$ For Binary As #2
    End If
    
    Offset& = 1                                    'seek pointer

'check File len vs a reasonable buffer
GetPage:                                               'Read the file
    If FileLeft& < Bufsize& Then                 'Check amount left to read
        buffer$ = Space$(FileLeft&)                'If less than our buffer, use lessor
    Else
        buffer$ = Space$(Bufsize&)                 'Otherwise use full buffer size
    End If

    Get #1, , buffer$                            'Read in a buffers worth
    ' OffSet& = Len(Buffer)                        'remember our seek pointer
  FileLeft& = FileLeft& - Offset&              'calculate file left for next pass
  'expand tabs
    If PC.ExpandTab Then
      If InStr(buffer$, Tb$) Then
        TCount% = 0
        'get a count of the tabs
        For x = 1 To Len(buffer$)
           If Mid$(buffer$, x, 1) = Tb$ Then
             TCount% = TCount% + 1
           End If
        Next x
        
        'create a temp buffer for tab expansion
        tBuffer$ = Space$(Len(buffer) + (TCount% * (tabcount - 1)))
        TotalSize& = TotalSize& + (TCount% * (tabcount - 1))
        
        Tx = 1                      'buffer counter
        i = 1                       '
        For x = 1 To Len(buffer$)       'scan through buffer
           t$ = Mid$(buffer$, x, 1)     'checking for a Tab char (chr$(9))
           If t$ = Tb$ Then             'if found
             Mid$(tBuffer$, Tx) = TabConst$ 'then replace with spaces
             i = i + 1
             Tx = Tx + tabcount
           Else
             Mid$(tBuffer$, Tx) = t$
             Tx = Tx + 1
           End If
         Next x
         
         If Len(tBuffer$) > Tx Then
           buffer$ = Left$(tBuffer$, Tx)
         Else
           buffer$ = tBuffer$
         End If
         tBuffer$ = ""
      End If
    End If      'end of expand tab code
    
  LeftOver% = 0
  ST = 1
  ST1 = ST

Do While ST < Len(buffer$)

        
    'watch for *** potential problem on MaxLen > FileLeft&
    t$ = Mid$(buffer$, ST, MaxLen%)     'grab a chunk of the buffer$
    If t$ = "" Then Exit Do
    T5 = InStr(t$, CRLF$)               'check for CRLF$
    If T5 Then                          'if there, then
       t$ = Mid$(t$, 1, T5 + 1)         'grab just the first line
    End If
    
    T4 = Len(t$)                        '
    txtWidth% = Printer.TextWidth(t$)
    SpaceFlag = True                    'check for spaces
    testlen = T1% - LeftOver%           'set TestLen to full or balance width of line
    If testlen < 0 Then
       testlen = 1
    End If
    
    Do While txtWidth% > testlen    'testlen is the maximum width
       If SpaceFlag Then            'space flag lets us bypass after first run
         Z = InstrRevJ(t$, " ")     'look backwards for a space
         If Z = 0 Then              'if none, set to bypass space check
            SpaceFlag = False       'on next loop
         End If
       End If
       
       If Z > 0 Then                        'there are spaces if Z > 0
          T4 = Z                            'set length for Mid$
          t$ = Mid$(buffer$, ST, T4)        'get current string
          t$ = RTrim$(t$)                   'trim spaces at end
          txtWidth% = Printer.TextWidth(t$)    'get width of string
       Else
          If T4 > 0 Then
          T4 = T4 - 1                       'solid line so decrement by one
          t$ = Mid$(buffer$, ST, T4)        'get string
          End If
          txtWidth% = Printer.TextWidth(t$)    'get width of string
       End If
    Loop
   
    If LeftOver Then LeftOver = 0

'--- poke string into buffer

'----------------------------------------------------------------
' This section corrects line errors
' when the line (T$) had several CRLF$'s
' It lets you add a portion of the next line so it doesn't leave
' a wierd break in the lines.
'----------------------------------------------------------------
  
    If T4 = MaxLen Then                 'we didn't g et a full Printer.length on the last line
      Temp$ = Mid$(buffer$, ST, T4)     'grab our T$
      T3% = InstrRevJ(Temp$, CRLF$)      'check for CRLF's
      If T3% < (Len(Temp$) - 1) Then    'if there is not a CRLF at the end of the line, then
          '--- Into the temp file
          Put #2, , Temp$
          Temp$ = Mid$(Temp$, T3% + 2, (T4 - T3)) 'get the width of the text after the CRLF
          LeftOver = Printer.TextWidth(Temp$)     'to add to the measured len above
      Else
          Put #2, , Temp$
      End If
      ST1 = ST1 + T4
    Else         'trim the tail of the line and push it into our buffer
      If Right$(t$, 2) = CRLF$ Then 'if it's got a crlf, just put it in
        Put #2, , t$
      Else
        Put #2, , RTrim$(t$) + CRLF$
      End If
      ST1 = ST1 + T4 + 2      'figure line plus crlf$
    End If
    ST = ST + T4            'point to next bunch of text
Loop
    
   Offset& = Offset& + Len(buffer$)              'Pointer into file (tally)
   FileLeft& = TotalSize& - Offset& + 1
   If Offset& <= TotalSize& Then
      Call frmStatus.SetProgress(TotalSize&, TotalSize& - FileLeft&)
      GoTo GetPage
   End If
   Close #1
   Close #2
Exit Sub

Problems:
Close
MsgBox ("Error " + Error)


End Sub

Sub WriteINIFile()
'write to ini or registry
AppName$ = "PCBook2"
WritePrivateProfileString AppName$, "HCurDate", Str$(PC.CurDate(0)), iniFile$
WritePrivateProfileString AppName$, "HFileTitle", Str$(PC.FileTitle(0)), iniFile$
WritePrivateProfileString AppName$, "HPgNumber", Str$(PC.PgNumber(0)), iniFile$
WritePrivateProfileString AppName$, "FCurDate", Str$(PC.CurDate(1)), iniFile$
WritePrivateProfileString AppName$, "FFileTitle", Str$(PC.FileTitle(1)), iniFile$
WritePrivateProfileString AppName$, "FPgNumber", Str$(PC.PgNumber(1)), iniFile$
WritePrivateProfileString AppName$, "FFileTitle", Str$(PC.FileTitle(1)), iniFile$
WritePrivateProfileString AppName$, "WidthFudge", Str$(PC.WidthFudge), iniFile$
WritePrivateProfileString AppName$, "LineLen", Str$(PC.LineLen), iniFile$
WritePrivateProfileString AppName$, "DoSig", Str$(PC.DoSig), iniFile$
WritePrivateProfileString AppName$, "ExpandTab", Str$(PC.ExpandTab), iniFile$

'added 1/4/2000
    tabcount% = frmMain.TCount.Text
WritePrivateProfileString AppName$, "TCount", Str$(tabcount%), iniFile$

WritePrivateProfileString AppName$, "WordWrap", Str$(PC.WordWrap), iniFile$
WritePrivateProfileString AppName$, "PrinterMode", Str$(PC.printermode), iniFile$
WritePrivateProfileString AppName$, "LastTempFile", TempFile$, iniFile$
WritePrivateProfileString AppName$, "Layout", Str$(PC.LM), iniFile$
'WritePrivateProfileString AppName$, "CurFontSize", Str$(Layout(PC.LM).rFontSize), iniFile$
WritePrivateProfileString AppName$, "DoBox", Str$(PC.DoBox), iniFile$
WritePrivateProfileString AppName$, "DoBook", Str$(PC.DoBook), iniFile$
WritePrivateProfileString AppName$, "FirstTime", "1", iniFile$
'WritePrivateProfileString AppName$, "CurrentFont", Module1.CurrentFont, iniFile$
WritePrivateProfileString AppName$, "TextFile", TextFile$, iniFile$
WritePrivateProfileString AppName$, "LineMultiple", Str$(PC.LineMultiple), iniFile$
WritePrivateProfileString AppName$, "MaxPages", Str$(PC.MaxPages), iniFile$
WritePrivateProfileString AppName$, "Layout0", Str$(Layout(0).rFontSize), iniFile$
WritePrivateProfileString AppName$, "Layout1", Str$(Layout(1).rFontSize), iniFile$
WritePrivateProfileString AppName$, "Layout2", Str$(Layout(2).rFontSize), iniFile$
WritePrivateProfileString AppName$, "Layout3", Str$(Layout(3).rFontSize), iniFile$

WritePrivateProfileString AppName$, "DefTab", Str$(PC.DefTab), iniFile$
WritePrivateProfileString AppName$, "Lineweight", Str$(lineweight%), iniFile$
WritePrivateProfileString AppName$, "Linecolor", Str$(linecolor), iniFile$

WritePrivateProfileString AppName$, "OffsetTop", Str$(Ofs.Top), iniFile$
WritePrivateProfileString AppName$, "OffsetLeft", Str$(Ofs.Left), iniFile$
WritePrivateProfileString AppName$, "OffsetRight", Str$(Ofs.Right), iniFile$
WritePrivateProfileString AppName$, "OffsetBottom", Str$(Ofs.Bottom), iniFile$

WritePrivateProfileString AppName$, "XEdgeBorder1", Str$(XEdgeBorder1), iniFile$
WritePrivateProfileString AppName$, "YEdgeBorder1", Str$(YEdgeBorder1), iniFile$

WritePrivateProfileString AppName$, "XEdgeBorder2", Str$(XEdgeBorder2), iniFile$
WritePrivateProfileString AppName$, "YEdgeBorder2", Str$(YEdgeBorder2), iniFile$

WritePrivateProfileString AppName$, "XEdgeBorder4", Str$(XEdgeBorder4), iniFile$
WritePrivateProfileString AppName$, "YEdgeBorder4", Str$(YEdgeBorder4), iniFile$


WritePrivateProfileString AppName$, "BookletGutter", Str$(BookletGutter), iniFile$
WritePrivateProfileString AppName$, "TwoUpGutter", Str$(TwoUpGutter), iniFile$
WritePrivateProfileString AppName$, "FourUpGutter", Str$(FourUpGutter), iniFile$
WritePrivateProfileString AppName$, "BoxToText", Str$(BoxToText), iniFile$

For x% = 0 To 3
   KeyName$ = "Layout" + Str$(x%) + " font"
   WritePrivateProfileString AppName$, KeyName$, Layout(x%).rFontName, iniFile$
Next x%
WritePrivateProfileString AppName$, "DoPath", Str$(PC.DoPath), iniFile$
WritePrivateProfileString AppName$, "LastPrinter", (Printer.DeviceName), iniFile$
End Sub
Function ReadINIFile() As Boolean

    PC.CurDate(0) = GetPrivateProfileInt(AppName$, "HCurDate", 0, iniFile$)
    PC.FileTitle(0) = GetPrivateProfileInt(AppName$, "HFileTitle", 0, iniFile$)
    PC.PgNumber(0) = GetPrivateProfileInt(AppName$, "HPgNumber", 0, iniFile$)
    PC.CurDate(1) = GetPrivateProfileInt(AppName$, "FCurDate", 0, iniFile$)
    PC.FileTitle(1) = GetPrivateProfileInt(AppName$, "FFileTitle", 0, iniFile$)
    PC.PgNumber(1) = GetPrivateProfileInt(AppName$, "FPgNumber", 0, iniFile$)
    
    'set our header/footer flag
    PC.DoHf(0) = PC.CurDate(0) Or PC.FileTitle(0) Or PC.PgNumber(0)
    PC.DoHf(1) = PC.CurDate(1) Or PC.FileTitle(1) Or PC.PgNumber(1)
    
    PC.LineLen = GetPrivateProfileInt(AppName$, "LineLen", 80, iniFile$)
    PC.WidthFudge = GetPrivateProfileInt(AppName$, "WidthFudge", 10, iniFile$)
    
    'added 1/4/2000
    tabcount% = GetPrivateProfileInt(AppName$, "TCount", 5, iniFile$)
    frmMain.TCount.Text = tabcount%
    
    PC.MaxPages = GetPrivateProfileInt(AppName$, "MaxPages", 2024, iniFile$)
    PC.DoSig = GetPrivateProfileInt(AppName$, "DoSig", 0, iniFile$)
    PC.ExpandTab = GetPrivateProfileInt(AppName$, "ExpandTab", 1, iniFile$)
    PC.WordWrap = GetPrivateProfileInt(AppName$, "WordWrap", 1, iniFile$)
    PC.printermode = GetPrivateProfileInt(AppName$, "PrinterMode", 1, iniFile$)
    PC.LM = GetPrivateProfileInt(AppName$, "Layout", 3, iniFile$)
    PC.DoBox = GetPrivateProfileInt(AppName$, "DoBox", 0, iniFile$)
    PC.DoBook = GetPrivateProfileInt(AppName$, "DoBook", 1, iniFile$)
    lineweight% = GetPrivateProfileInt(AppName$, "Lineweight", 1, iniFile$)
    linecolor = GetPrivateProfileInt(AppName$, "Linecolor", 0&, iniFile$)
    Ofs.Top = GetPrivateProfileInt(AppName$, "OffsetTop", 0, iniFile$)
    Ofs.Left = GetPrivateProfileInt(AppName$, "OffsetLeft", 0, iniFile$)
    Ofs.Right = GetPrivateProfileInt(AppName$, "OffsetRight", 0, iniFile$)
    Ofs.Bottom = GetPrivateProfileInt(AppName$, "OffsetBottom", 0, iniFile$)
    
    XEdgeBorder1 = GetPrivateProfileInt(AppName$, "XEdgeBorder1", 720, iniFile$)
    YEdgeBorder1 = GetPrivateProfileInt(AppName$, "YEdgeBorder1", 720, iniFile$)
    
    XEdgeBorder2 = GetPrivateProfileInt(AppName$, "XEdgeBorder2", 720, iniFile$)
    YEdgeBorder2 = GetPrivateProfileInt(AppName$, "YEdgeBorder2", 720, iniFile$)
    
    XEdgeBorder4 = GetPrivateProfileInt(AppName$, "XEdgeBorder4", 720, iniFile$)
    YEdgeBorder4 = GetPrivateProfileInt(AppName$, "YEdgeBorder4", 720, iniFile$)
    
    BookletGutter = GetPrivateProfileInt(AppName$, "BookletGutter", 1440, iniFile$)
    TwoUpGutter = GetPrivateProfileInt(AppName$, "TwoUpGutter", 1440, iniFile$)
    FourUpGutter = GetPrivateProfileInt(AppName$, "FourUpGutter", 1440, iniFile$)
    BoxToText = GetPrivateProfileInt(AppName$, "BoxToText", 270, iniFile$)
    
    'Layout(PC.LM).rFontSize = GetPrivateProfileInt(AppName$, "CurFontSize", 8, iniFile$)
    
    lMult$ = Space$(5)              'up to 5 digits (4 + decimal)
    GetPrivateProfileString AppName$, "LineMultiple", "1.25", lMult$, Len(lMult$), iniFile$
    PC.LineMultiple = Val(lMult$)
    LastTempFile$ = Space$(128)
    GetPrivateProfileString AppName$, "LastTempFile", "", LastTempFile$, 128, iniFile$
    LastTempFile$ = ZTrim$(LastTempFile$)
    
    TextFile$ = Space$(128)
    GetPrivateProfileString AppName$, "TextFile", "", TextFile$, 128, iniFile$
    TextFile$ = ZTrim$(TextFile$)
    If Not Exist(TextFile$) Then
      TextFile$ = ""
    End If
    
    Module1.CurrentFont = Space$(64)
    GetPrivateProfileString AppName$, "CurrentFont", "Times New Roman", Module1.CurrentFont, 64, iniFile$
    Module1.CurrentFont = ZTrim$(Module1.CurrentFont)
    For x% = 0 To 3
        Temp$ = Space$(64)
        KeyName$ = "Layout" + Str$(x%) + " font"
        GetPrivateProfileString AppName$, KeyName$, "Times New Roman", Temp$, 64, iniFile$
        Layout(x).rFontName = ZTrim$(Temp$)
    Next x%
    
    Layout(0).rFontSize = GetPrivateProfileInt(AppName$, "Layout0", 8, iniFile$)
    Layout(1).rFontSize = GetPrivateProfileInt(AppName$, "Layout1", 6, iniFile$)
    Layout(2).rFontSize = GetPrivateProfileInt(AppName$, "Layout2", 4, iniFile$)
    Layout(3).rFontSize = GetPrivateProfileInt(AppName$, "Layout3", 8, iniFile$)
    PC.DefTab = GetPrivateProfileInt(AppName$, "DefTab", 0, iniFile$)
    PC.DoPath = GetPrivateProfileInt(AppName$, "DoPath", 1, iniFile$)
    Temp$ = Space$(64)
    CurrentPrinter$ = Printer.DeviceName
           
    GetPrivateProfileString AppName$, "LastPrinter", CurrentPrinter$, Temp$, 64, iniFile$
    Temp$ = ZTrim$(Temp$)
    If CurrentPrinter$ <> Temp$ Then   'if currentprinter <> saved one then try to assign it
    'Dim p As Printer
    Set P = Printer
    For Each P In Printers
      If Temp$ = P.DeviceName Then
        Set Printer = P
        Exit For
      End If
    Next
    End If
    
    'If there was a last temp file (unnatural ending) then kill it
    If Len(LastTempFile$) Then
        If Exist(LastTempFile$) Then
            Kill LastTempFile$
        End If
    End If
    ReadINIFile = True
End Function

Public Sub GetOptions()
    'fill in here reading the controls from the main screen
    
    With frmMain
     PC.PgNumber(0) = .HPageNum.Value
     PC.FileTitle(0) = .HFilename.Value
     PC.CurDate(0) = .HDate.Value
     PC.DoHf(0) = PC.CurDate(0) Or PC.FileTitle(0) Or PC.PgNumber(0)
     
     PC.DoSig = .DoSig.Value
     PC.ExpandTab = .DoTabEx.Value
    
     PC.PgNumber(1) = .FPageNum.Value
     PC.FileTitle(1) = .FFileName.Value
     PC.CurDate(1) = .FDate.Value
     
     PC.DoHf(1) = PC.CurDate(1) Or PC.FileTitle(1) Or PC.PgNumber(1)
     
     If .DoWordWrap.Visible Then    '1/4/2000 modification
        PC.WordWrap = .DoWordWrap
     End If
     PC.papersize = Printer.papersize
     PC.printermode = frmMain.GetPrinterMode
     PC.DoBox = .DoOutlines.Value
    End With
     
     PC.DoBook = frmMain.DoBooklet.Value
     For x = 0 To 2 'check layout selection buttons and set PC.LM correctly
       If frmMain.LayoutSelection(x).Value Then
         If x = 1 And frmMain.DoBooklet.Value Then
           PC.LM = 3
           Exit For
         End If
         PC.LM = x
         Exit For
       End If
    Next x
End Sub
Public Sub SetOptions()
'set interface display to values stored in our PC structure
    With frmMain
    .HPageNum.Value = PC.PgNumber(0)
    .HFilename.Value = PC.FileTitle(0)
    .HDate.Value = PC.CurDate(0)
    .FDate.Value = PC.CurDate(1)
    .FFileName.Value = PC.FileTitle(1)
    .FPageNum.Value = PC.PgNumber(1)
    .DoTabEx.Value = PC.ExpandTab         'expand tabs
    .DoSig.Value = PC.DoSig               'signatures
    .DoWordWrap.Value = PC.WordWrap       'Wordwrap
    .DoOutlines.Value = PC.DoBox           'remember box
    If PC.DoBook Then frmMain.DoBooklet.Value = 1
    If PC.LM = 3 Then   'set both booklet and layout if needed
       frmMain.LayoutSelection(1).Value = True
       frmMain.DoBooklet.Value = 1
    Else
       .LayoutSelection(PC.LM).Value = True
       .DoBooklet.Value = 0
    End If
    frmMain.SetPrinterMode PC.printermode
    If PC.fontsize Then
      Printer.fontsize = PC.fontsize
    Else
      PC.fontsize = Printer.fontsize        'was int(printer.fontsize)
    End If
    
    Printer.FontName = Layout(PC.LM).rFontName  'set font name
    
    'display preview of font
    Call frmMain.SetFontPreview(Printer.FontName, Printer.fontsize)
        
    End With
End Sub

Function Exist(FileName$) As Boolean
'checks to see if a file exists. Using input opens for read
'only, so it doesn't write a new file like binary does
'nor chokes on read only files
On Error GoTo DoesntExist
    Open FileName$ For Input As #99
    Close #99
    Exist = True
    Exit Function
DoesntExist:
    Exist = False

End Function

Sub PagePrintOutput(Xstart&, Ystart&, buffer$)
   'put in loop to check buffer against chr$(13)+(10) or
   'chr$(12)
   'use x,y coords to position strings
   cy& = Ystart&
      
   Printer.CurrentX = Xstart&
   Printer.CurrentY = cy&
   ICounter = 1
              
   dy& = Layout(PC.LM).rLineSpace  '  charheight * PC.LineMultiple
   fLen = Len(buffer$)
   
   Do While ICounter < fLen
      CRLFCtr = InStr(ICounter, buffer$, CRLF$)
      PFCtr = InStr(ICounter, buffer$, Chr$(26))
      If PFCtr Then
        If CRLFCtr < PFCtr Then
            DelimitCtr = CRLFCtr
            Offset = 2
        Else
            DelimitCtr = PFCtr
            Offset = 1
        End If
      Else
        DelimitCtr = CRLFCtr
        Offset = 2
      End If
    tLen = DelimitCtr - ICounter
    If tLen > 0 Then
      Temp$ = Mid$(buffer$, ICounter, tLen)
      ICounter = DelimitCtr + Offset
      'trim leading spaces
      'Printer.Print LTrim$(temp$)
      Printer.Print Temp$
    ElseIf ICounter > fLen Then
      'this is for the last line in file, no crlf
      Temp$ = Mid$(buffer$, ICounter, fLen)
      ICounter = fLen + 1
      'trim leading spaces
      'Printer.Print LTrim$(temp$)
      Printer.Print Temp$
    Else
      ICounter = DelimitCtr + Offset
    End If
    Printer.CurrentX = Xstart     'reset to start
    cy& = cy& + dy&
    Printer.CurrentY = cy&        'add line space
    dummy = DoEvents()            'let things happen
 Loop

End Sub

Sub SetLayoutArray(fontSz%)
'This section sets up the layout type array for page sizes and
'coordinates of pages.  0 = 1 up, 1 = 2 up (1 side), 2 = 4 up, 3 = 2 up (booklet)
'using scale height and width.
'the initial measurements are set with the INI file
'8/1/99 changes
' higher granularity
'
On Error GoTo SLAError
'either set defaults or recalculate on the fly

Printer.ScaleMode = vbTwips
Printer.Orientation = 1

'----- Start by getting full width of paper and calculating the
'      printable area
'NonprintW = Printer.Width - Printer.ScaleWidth
'NonprintH = Printer.Height - Printer.ScaleHeight


'----- layout 0 = full page WinPrn mode
Layout(0).rVPage = 1               'number of virtual pages p
Layout(0).rOrientation = 1      'portrait
Layout(0).rVpagelength = Printer.ScaleHeight - (2 * YEdgeBorder1)  '0   'page height
Layout(0).rVpageWidth = Printer.ScaleWidth - (2 * XEdgeBorder1)  'page width
Layout(0).rX1(1) = XEdgeBorder1 + Ofs.Left         'left edge
Layout(0).rY1(1) = YEdgeBorder1 + Ofs.Top         'top margin

'----- layout 2  = 4 up WinPrn mode
Layout(2).rVPage = 4            'vert pages
Layout(2).rOrientation = 1      'portrait
Layout(2).rVpagelength = (Printer.ScaleHeight \ 2) - ((FourUpGutter \ 2) + YEdgeBorder4) - (Ofs.Left + Ofs.Right) ' - (FourUpGutter) '- 1440
Layout(2).rVpageWidth = (Printer.ScaleWidth \ 2) - ((FourUpGutter \ 2) + XEdgeBorder4) - (Ofs.Bottom + Ofs.Top) ' - (FourUpGutter)  ' 1440  'page width
'page 1


Layout(2).rX1(1) = XEdgeBorder4 + Ofs.Left   '720      'left edge
Layout(2).rY1(1) = YEdgeBorder4 + Ofs.Top    '720      'top margin
'page 2
Layout(2).rX1(2) = (Printer.ScaleWidth \ 2) + (FourUpGutter \ 2) + Ofs.Left '540
Layout(2).rY1(2) = YEdgeBorder4 + Ofs.Top          'top margin page 2
'page 3
Layout(2).rX1(3) = XEdgeBorder4 + Ofs.Left    '720         '6300         'left edge page 3
Layout(2).rY1(3) = (Printer.ScaleHeight \ 2) + (FourUpGutter \ 2) + Ofs.Top ' 540   'top margin page 3
'page 4
Layout(2).rX1(4) = (Printer.ScaleWidth \ 2) + (FourUpGutter \ 2) + Ofs.Left '540      'left edge page 4
Layout(2).rY1(4) = (Printer.ScaleHeight \ 2) + (FourUpGutter \ 2) + Ofs.Top ' 540     'top margin page 4
    
   
Printer.Orientation = 2             'set to landscape

'----- layout 1 = 2 up WinPrn mode
Layout(1).rVPage = 2            'vpages
Layout(1).rOrientation = 2      'landscape
Layout(1).rVpagelength = Printer.ScaleHeight - (YEdgeBorder2 * 2) - (Ofs.Top + Ofs.Bottom) '1440
Layout(1).rVpageWidth = (Printer.ScaleWidth \ 2) - (XEdgeBorder2 + (TwoUpGutter \ 2)) - (Ofs.Left + Ofs.Right) '1440  '1080 'page width

Layout(1).rX1(1) = XEdgeBorder2 + Ofs.Top      '720          'left edge
Layout(1).rY1(1) = YEdgeBorder2 + Ofs.Right        '720          'top margin
Layout(1).rX1(2) = (Printer.ScaleWidth \ 2) + (TwoUpGutter \ 2) + Ofs.Top '720   '540 '8100         'left edge page
Layout(1).rY1(2) = YEdgeBorder2 + Ofs.Right  '720          'top margin page 2

'----- layout 3 = 2 up booklet
Layout(3).rVPage = 2
Layout(3).rOrientation = 2      'landscape

Layout(3).rVpagelength = Printer.ScaleHeight - (YEdgeBorder2 * 2) - (Ofs.Top + Ofs.Bottom) '1440
Layout(3).rVpageWidth = (Printer.ScaleWidth \ 2) - (XEdgeBorder2 + (BookletGutter \ 2)) - (Ofs.Left + Ofs.Right)  '1440 '1\2 border each side
Layout(3).rX1(1) = XEdgeBorder2 + Ofs.Top  '720          'left edge
Layout(3).rY1(1) = YEdgeBorder2 + Ofs.Right ' 720          'top margin
Layout(3).rX1(2) = (Printer.ScaleWidth \ 2) + (BookletGutter \ 2) + Ofs.Top '945 '720   'center + 1/2"
Layout(3).rY1(2) = YEdgeBorder2 + Ofs.Right '720          'top margin page

'called when user resets fonts
If fontSz% Then Call resetLayout(fontSz%)
Exit Sub
SLAError:
dummy = ErrorHandler(err, fctn$)

End Sub

Sub resetLayout(fontSz%)
'sets up current layout params with new font,linespace and lines per page
If fontSz% Then
   Printer.fontsize = fontSz%
   Layout(PC.LM).rFontSize = fontSz%
   Layout(PC.LM).rLineSpace = Printer.TextHeight("ABCDEFGHIJKLMNOPQRSTUVWXYZ") * PC.LineMultiple
   Layout(PC.LM).rLinesPerPage = Layout(PC.LM).rVpagelength \ Layout(PC.LM).rLineSpace
End If
End Sub

Sub GenHeaderFooter(Page%, HFFlag%)
    'printer a generic header or footer based on incoming HFFlag
    'HFFlag: Header = 0, Footer = 1
    'Set up Y axis based on header/footer
    If HFFlag Then
        'footer = top anchor + page length - one line height
        Printer.CurrentY = Layout(PC.LM).rY1(PC.SPN) + (Layout(PC.LM).rVpagelength - Layout(PC.LM).rLineSpace)
    Else
        'header = Top anchor
        Printer.CurrentY = Layout(PC.LM).rY1(PC.SPN)
    End If
       'if it's a footer draw a line first
   If HFFlag% = 1 And PC.DoBox = 0 Then
      Ty& = Printer.CurrentY
      Tx& = Layout(PC.LM).rX1(PC.SPN)
      Printer.Line (Tx&, Ty&)-(Tx& + Layout(PC.LM).rVpageWidth, Ty&)
      'move line down 1/2 a line space
      Printer.CurrentY = Printer.CurrentY + (Layout(PC.LM).rLineSpace \ 2)
   End If
      
    If PC.FileTitle(HFFlag) Then      'Print the filename
      If PC.DoPath Then
        iTextFile$ = ParseFileName$(TextFile$)
        Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN) + ((Layout(PC.LM).rVpageWidth - Printer.TextWidth(iTextFile$)) \ 2)
        Printer.Print iTextFile$;            'print filename
      Else
        Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN) + ((Layout(PC.LM).rVpageWidth - Printer.TextWidth(TextFile$)) \ 2)
        Printer.Print TextFile$;            'print filename
      End If
    End If
   
     'Put page number in outside corner
    If PC.PgNumber(HFFlag) Then                          'Print the current page
      PTemp$ = "Page" + Str$(Page%)
      If PC.LM = 3 Then     ' 3 = booklet     'changed 1/4/2000
        If Page% Mod 2 Then
            'right page number = set to right margin - length of text
            Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN) + (Layout(PC.LM).rVpageWidth - Printer.TextWidth(PTemp$))
        Else
            'left page number = left margin
            Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN)  'set to left edge
        End If
      Else      'single pages
        Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN) + (Layout(PC.LM).rVpageWidth - Printer.TextWidth(PTemp$))
      End If
      
      Printer.Print PTemp$;
    End If
   
   'put date in inside corner
   
    If PC.CurDate(HFFlag) Then                           'Print the current date
      If PC.LM = 3 Then     '3 = booklet     'changed 1/4/2000
        If Page% Mod 2 Then
            'right side, put on inside margin
            Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN)
        Else
            'left side, put at right edge
            Printer.CurrentX = (Layout(PC.LM).rX1(PC.SPN) + (Layout(PC.LM).rVpageWidth - Printer.TextWidth(CurrentDate$)))
        End If
      Else
        Printer.CurrentX = Layout(PC.LM).rX1(PC.SPN)
      End If
     Printer.Print CurrentDate$;
   End If
   
   'draw a line under the header or footer
   '  unless there is a box around the page
   If HFFlag% = 0 Then  'draw a line under the header
      Ty& = Printer.CurrentY + Layout(PC.LM).rLineSpace
      Tx& = Layout(PC.LM).rX1(PC.SPN)
      Printer.Line (Tx&, Ty&)-(Tx& + Layout(PC.LM).rVpageWidth, Ty&)
   End If
End Sub
Sub PrintBox(Lineweight1%)       'usually 1
    'put a line around the page at approx 1/4" from the edge
    Dim X1, X2, Y1, Y2 As Long
    Printer.DrawWidth = Lineweight1%
    
    X1 = Layout(PC.LM).rX1(PC.SPN) - BoxToText  '360
    Y1 = Layout(PC.LM).rY1(PC.SPN) - BoxToText  '360
    X2 = Layout(PC.LM).rVpageWidth + X1 + (BoxToText * 2) '720
    Y2 = Layout(PC.LM).rVpagelength + Y1 + (BoxToText * 2) '720
    
    Printer.Line (X1, Y1)-(X2, Y2), QBColor(linecolor), B
    
End Sub

Sub WinPrnMode() 'This module prints with the
                 ' format of Jeff Prosise's WinPrn
Dim StepSize, ILoop As Integer
On Error GoTo PrinterError2

'show status
Call frmMain.ShowStatus("Printing " + printMsg$(PC.LM))

'set map mode
Printer.ScaleMode = vbTwips
Printer.Orientation = PC.Orientation
Printer.FontName = Layout(PC.LM).rFontName
Printer.fontsize = Layout(PC.LM).rFontSize

'get just the file name for headers/footers
Open TempFile$ For Binary As #1     'open formatted temp file

'calculate a fudge factor for some head room around headers
If PC.DoHf(0) Then              'this moves the top down for the header
    Fudge% = (Layout(PC.LM).rLineSpace * 2)
Else
    Fudge% = 0
End If

 '--- Single Sided
GoSub StraightPage
    
Close #1
frmMain.ShowStatus "Printing Completed"  'Report on progress

Exit Sub
StraightPage:
    
    '--- From pageprint
    For PageToDo% = 1 To PC.TotalPages
      Call frmStatus.SetProgress(PC.TotalPages, PageToDo%)
      GoSub Selectpage
    Next PageToDo
Return

PrinterError2:
    Resume here2
here2:
Exit Sub

Selectpage:
  '--- LM = Layout Mode (1, 2, 4 up)
  Select Case PC.LM
    Case 0              'single
      PC.SPN = 1        'current side
      GoSub PageOut
      GoSub PageFeed
      
    Case 1      '2 up
        PC.SPN = Abs((PageToDo Mod 2) - 2)  'get left or right page
        GoSub PageOut
        If PC.SPN = 2 Then
          GoSub PageFeed
        Else
          If PageToDo = PC.TotalPages Then Printer.EndDoc
        End If
        
    Case 2      '4 up   portrait mode
        PC.SPN = PageToDo Mod 4   'get page num
        If PC.SPN = 0 Then PC.SPN = 4
        GoSub PageOut
        If PC.SPN = 4 Then
          GoSub PageFeed
        Else
          If PageToDo = PC.TotalPages Then Printer.EndDoc
        End If
    Case Else
  End Select
Return

PageOut:
  If PtrArray&(PageToDo% + 1) Then   'Put in This space intentionally blank
    '--- check and call header routine
 If PC.DoBox Then Call PrintBox(lineweight)  '1 = line weight
     If PC.DoHf(0) Then Call GenHeaderFooter(PageToDo%, 0) 'Header if needed
      buffer$ = Space$(PtrArray&(PageToDo% + 1) - PtrArray&(PageToDo%))
      Get #1, PtrArray&(PageToDo%), buffer$      'Read in a page
      If InStr(buffer$, FF$) Then                 'If the last character is a PF
        Call PagePrintOutput(Layout(PC.LM).rX1(PC.SPN), Layout(PC.LM).rY1(PC.SPN) + Fudge%, Left$(buffer$, InStr(buffer$, FF$) - 1))
      Else
        Call PagePrintOutput(Layout(PC.LM).rX1(PC.SPN), Layout(PC.LM).rY1(PC.SPN) + Fudge%, buffer$)
      End If
      If PC.DoHf(1) Then Call GenHeaderFooter(PageToDo%, 1) 'Footer if needed
    
    End If

Return
PageFeed:           'feeds appropriate newpage or enddoc
    If PageToDo = PC.TotalPages Then
      Printer.EndDoc
    Else
       Printer.NewPage
    End If
Return
End Sub

Function SetAll() As Integer
'start by checking our users selections
On Error GoTo SetAllError
    ' get options from controls
    Call GetOptions
    ' set printer font size based on our layout
    Printer.fontsize = Layout(PC.LM).rFontSize '  PC.FontSize
    '
    Printer.Orientation = Layout(PC.LM).rOrientation ' PC.Orientation
    Call frmMain.SetFontPreview(Printer.FontName, Printer.fontsize)
    
    SetAll = 0          'return with no errors
        
    Exit Function

SetAllError:    'get error code
    SetAll = ErrorHandler(err, "SetAll")
        
    Resume SAHere
SAHere:
    'exit with error
End Function

Function ZTrim$(stripString$)
'ZTrim checks a string for a chr$(0), or C String, and clips it off
Zero% = InStr(stripString$, Chr$(0))
If Zero% Then
   ZTrim$ = Left$(stripString$, Zero% - 1)
Else
   ZTrim$ = stripString$
End If
End Function
Function ErrorHandler(err As ErrObject, Fnct$) As Integer
Select Case err.Number
Case 380            'function not supported
  MsgBox "Your Printer - " + Printer.DeviceName + " does not support features needed for PCBook2. Please select another printer"
Case Else
  MsgBox "Error: " + err.Description
End Select

ErrorHandler = err.Number
End Function
Function RoundNum(num) As Integer
    'Round the font size number for display.
    TNum2 = Int(num)
    TNum = num - TNum2
    RoundNum = TNum2 + Abs(TNum > 0.5)
End Function
Function InstrRevJ(SString$, FString$) As Long
  'emulates InstrRev in visual basic 6
  Dim Fnd As Boolean
  J& = Len(FString$)
  For i& = Len(SString$) To 1 Step -1
    If Mid$(SString$, i&, J&) = FString$ Then
      Fnd = True
      Exit For
    End If
  Next i&
  If Fnd Then
    InstrRevJ = i&
  Else
    InstrRevJ = 0&
  End If
End Function

Function CheckPrinter() As Boolean

 lpDeviceName$ = Printer.DeviceName
 
 lpPort = Printer.Port

'check duplex, not critical
 If DeviceCapabilities(lpDeviceName$, lpPort, DC_DUPLEX, lpOutput, lpdevmode) = 0 Then
    frmMain.printermode(2).Enabled = False
 Else
    If PC.DoBook Then
      frmMain.printermode(2).Enabled = True
    End If
 End If
 
Temp2 = DeviceCapabilities(lpDeviceName$, lpPort, DC_ORIENTATION, lpOutput, lpdevmode)
 'If DeviceCapabilities(lpDeviceName$, lpPort, DC_ORIENTATION, lpOutput, lpdevmode) = 0 Then
If Temp2 = 0 Then
    CheckPrinter = True
    Exit Function
 End If

  TestResult = DeviceCapabilities(lpDeviceName$, lpPort, DC_TRUETYPE, lpOutput, lpdevmode)
   
  CheckPrinter = False
Exit Function
ChecksBad:
   CheckPrinter = True
End Function

Function PrinterSelector() As Boolean
            
ReStartPrinter:
          PrtDlg.Show
          dummy = DoEvents()
          Exit Function
            
PSErrhandler:
  MsgBox err.Description
End Function

Function GetFont()
    cf.lStructSize = Len(cf)
    cf.flags = CF_APPLY Or CF_TTONLY Or CF_PRINTERFONTS Or CF_SCALABLEONLY Or CF_LIMITSIZE
    cf.nSizeMax = 18
    cf.nSizeMin = 4
    cf.hdc = Printer.hdc
    Temp$ = Space$(LF_FACESIZE)
    'lgf.lfFaceName = VarPtr(temp$)
    'cf.lpLogFont = VarPtr(lgf)
    
    dummy = CHOOSEFONT(cf)
    Temp = lgf.lfFaceName
 
End Function
Function getprinter()
    
    If P.DeviceName = Printer.DeviceName Then
       FontDlg.List1(0).AddItem P.DeviceName + " *"
       J% = FontDlg.List1(0).ListCount
'       Call FillListWithFonts        'get fonts on default printer
    Else
       FontDlg.List1(0).AddItem P.DeviceName
    End If

End Function

Sub FillListWithFonts(LB As ListBox)
    Dim hdc As Long
    LB.Clear
    '-- changed from listbox fonts to printer fonts
    hdc = Printer.hdc
    EnumFontFamilies hdc, vbNullString, AddressOf EnumFontFamProc, LB
    ReleaseDC LB.hwnd, hdc
    FontDlg.Text1(0).Text = CurrentFont$
'    PC.fontsize = Printer.fontsize
      
End Sub


Function EnumFontFamProc(lpNLF As LOGFONT, lpNTM As NEWTEXTMETRIC, ByVal Fonttype As Long, LParam As ListBox) As Long
     Dim FaceName As String
     Dim FullName As String
    
     FaceName = StrConv(lpNLF.lfFaceName, vbUnicode)
     
     'strip off zero
     FaceName = ZTrim$(FaceName)   ' Left$(FaceName, InStr(FaceName, vbNullChar) - 1)
     
     flagged$ = ""
     
     '-- flag the currently selected font
     If FaceName = Printer.Font Then
        flagged$ = " *"             'Put each font into list box
     End If
    
    'limit fonts to truetype
        If Fonttype And TRUETYPE_FONTTYPE Then
            LParam.AddItem FaceName '+ flagged$
        End If
        
        If Len(flagged$) Then
           PC.FontDisplayed = True
           CurrentFont$ = FaceName
        End If
    ' End If
     EnumFontFamProc = 1
End Function

